<?php

namespace Drupal\tmgmt_contentapi\Form;

use Drupal\Core\Form\ConfirmFormBase;
use Drupal\Core\Form\FormStateInterface;
use \Drupal\Core\Url;

/**
 * Form with examples on how to use cache.
 */
class TriggerImport extends ConfirmFormBase  {

  /**
   * {@inheritdoc}
   */
  public function getQuestion() {
    // Add your question here.
  }

  /**
   * {@inheritdoc}
   */
  public function getCancelUrl() {
    // Add the cancel URL here.
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'download_and_import_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {

    $form['description'] = [
      '#type' => 'markup',
      '#markup' => $this->t('Click on import in batches button to import ready jobs.<br/>'),
    ];
   
    // Submit button.
    $form['submit'] = [
      '#type' => 'submit',
      '#value' => 'Import jobs in batches',
    ];
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    // No validation logic needed for this form.
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $translators = \Drupal::entityTypeManager()->getStorage('tmgmt_translator')->loadByProperties(['plugin' => 'contentapi']);
    if (!$translators) {
      return;
    }
    foreach ($translators as $translator) {
      // Receive all processed translations.
      $config = $translator->getSetting('cron-settings');
      // Make sure cron is enabled for this translator.
      if (!$config['status']) {
        \Drupal::logger('TMGMT_CONTENTAPI')->notice('Cron disabled for translator %translator', [
          '%translator' => $translator->label(),
        ]);
        continue;
      }
      // Process job, update status, acknowledge, download and import.
      \Drupal::service('tmgmt_contentapi.process_job')->filterAknowledgeDownloadJobs('');
    }
  }
}
