<?php

namespace Drupal\tmgmt_contentapi\Plugin\QueueWorker;

use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\Core\Queue\QueueWorkerBase;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\tmgmt\Entity\Job;

/**
 * Process a queue of translated jobs.
 *
 * @QueueWorker(
 *   id = "import_translated_jobs_from_queue",
 *   title = @Translation("Import translated jobs from queue"),
 *   cron = {"time" = 60}
 * )
 */
class ImportTranslatedJobsFromQueue extends QueueWorkerBase implements ContainerFactoryPluginInterface {

  /**
   * Constructs a new class instance.
   *
   * @param array $configuration
   *   A configuration array containing information about the plugin instance.
   * @param string $plugin_id
   *   The plugin_id for the plugin instance.
   * @param mixed $plugin_definition
   *   The plugin implementation definition.
   * @param \Drupal\Core\Entity\EntityTypeManagerInterface $entity_type_manager
   *   Entity type manager service.
   */
  public function __construct(array $configuration, $plugin_id, $plugin_definition) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    return new static(
      $configuration,
      $plugin_id,
      $plugin_definition,
    );
  }

  /**
   * {@inheritdoc}
   */
  public function processItem($data) {
 /*
    $idarray  = $data['idarray'];
    $job_info = $data['job_info'];
*/
    $requestId = $data['request_id'];
    $jobId = $data['job_id'];
    $drupalJob = Job::load($data['tjid']);
    $context = $data['context'];

    \Drupal::service('tmgmt_contentapi.process_job')->processRequestIdNew($jobId, $requestId, $drupalJob, $context);
  }

}
